IT: OTS (China) - 1100 #297

Add summary total points group by operator in turnover function
07/25/2023 04:43 PM - Xihua Fan

Status: oo0 Start date: 08/23/2023
Priority: I Due date: 08/25/2023
Assignee: Zhongbao Ye % Done: 100%
Category: Estimated time: 24.00 hours
Target version: v3.0 Spent time: 19.00 hours
Description
Task Details

e [turnover function] 000000000000000

o Titlel[

Teamll[IDisplay Products total points: -> Team points:
OperatorDDDispIay Products total points: -> Personal points:
« Operatorlll0Specialll000000
00Andy: 90.76 -> 90.76 Special: Order Qty(100) Points(10)
Speciallll = [Special - 000000 O0[Special - Display 0l Special - Promotion]

« (00000000order100000Production Startedl0000000000000000000000000000000Dapingll00Order Finishedll

« turnover points 10000000
Point (P): 1000000000000000000
Quantity (Q): 000000
Index1 - 3 (11-3): (0300000000
Coefficient1 - 3 (C1-3): (3000000000000

Coefficient4 (C4)1000000000Quantity >= Index40000 000 [ No. Rema | Urgen | Rank1 | Rank2 | Rank3 | Rank4
ke cy Q<= N< 112 < Q>
I Q<= | Q<= 13
12 13
1 No Norma |P1 = P2 = P3 = P4 =
I Q/n1 |C1 + |C1 + |C1 +
*C1 (Q-1) [(12-11) [@2-11)
/= /1 /M
Cc2 C2 + C2 +
Q- (13 -
2)/11 [12)/11
*C3 *C3
2 No Expres [P1/2 |P2/2 |P3/2 |P4/2
]
3 No Doubl |P1 P2 P3 P4
eExpr
ess
4 Yes Norma |P1x3 |P2x3 |P3x3 [P4x3
I
5 Yes Expres [P1x3 |P2x3 |P3x3 [P4x3
]
6 Yes Doubl [P1x3 |P2x3 |P3x3 [P4x3
eExpr
ess

® Questions
1. Remake = 1 and Urgency = DoubleExpress [0, 3000000Normall0000000

DapingllbugllRemakel00030000000Remakel00000000 Urgency=DoubleExpressll 00 #294
2. Operator [l orderllll 000000000t order_historyll00000000000peratorl100000Operator = Production Started
DapingllOK0000000000 Operator = Production Started or Ready for Shipment
3. Operator 100000000000000000+0rder0000

Daping: 000000perator(0000
4. Operator [0 0thersII000000Operators

Daping:

« (000000perators0000000000000perators = User Rolelloperatorland Is Blocklfalselland Companey Abbreviation] RBSH
land Is Deletellfalsell
e For non- RBSH personnel, personal data in the turnover cannot be viewed.
Input
¢ Daping
Output

¢ Report and Solution

Others

History

#1 - 07/25/2023 04:44 PM - Xihua Fan
- File turn over.png added

#2 - 07/31/2023 08:07 PM - Xihua Fan

- Description updated

#3 - 08/01/2023 10:46 AM - Xihua Fan

- Description updated

#4 - 08/01/2023 04:00 PM - Xihua Fan

- Description updated

#5 - 08/17/2023 05:55 PM - Zhongbao Ye

- Due date changed from 08/31/2023 to 08/28/2023
- Start date changed from 08/01/2023 to 08/24/2023
- Estimated time changed from 8.00 h to 24.00 h

#6 - 08/18/2023 10:37 AM - Xihua Fan
- Due date changed from 08/28/2023 to 08/25/2023
- Start date changed from 08/24/2023 to 08/23/2023

#7 - 08/23/2023 10:56 AM - Zhongbao Ye
Output(2023/08/23 ~ 2023/08/24 11)

e Databases :

CREATE TABLE "t_order_history ™ (
tidt bigint(ZO) NOT NULL AUTO_INCREMENT COMMENT '0000001IDOODO",
‘order_id' bigint (20) NOT NULL COMMENT '00ID',
‘order_product_id’ bigint (20) NOT NULL COMMENT '00001ID',
‘order_product_status® varchar(5) NOT NULL COMMENT '000000°',
‘create_user’ bigint (20) NOT NULL COMMENT '00001ID',
‘create_time’ int (15) unsigned NOT NULL COMMENT '0000°',
‘update_user’ bigint (20) NOT NULL COMMENT '00001ID',
‘update_time’ int (15) unsigned NOT NULL COMMENT '0000°',
PRIMARY KEY ( id"),
KEY ‘“order_id' ( order_id’),
KEY "“order_product_id"® (" order_product_id"),
KEY "“order_product_status® ( order_product_status’ ),
KEY “create_user’ ( create_user’)

) ENGINE=InnoDB DEFAULT CHARSET=utf8 ROW_FORMAT=COMPACT COMMENT='0000000"
e Vani00000000

1.00000000 DCOMMENT 'ID' -> COMMENT ‘0000000000

2.00 O00order idlorder_product_idl0000000uNIQUE INDEXOOOOOOO00000000000DselectlO0NDOO
Note0000000000000000000000000where000000000

3.00000000 Oupdate userlupdate timelll000InsertlSelectlI00000Update

4.0000 Onistoryll0000statusO00000000000000000000000create_userl000000000000000000000
d00oTsO000000000count+y0OO0000D0D = 100 ooo OOOO0OOOOOOOOOODOOOOD

e Bruce 00l

1.0000000,sq 000
2.0000000000sqn 00000000400000000rder_id,order_product_id,order_product_status,create_userl1000000000000000000
3.HHHHHHHHD|]|]|]|]|]DDDDDDDDDDDDDDDDDDDDDDD
4.
1.000000000000000000000000000DOOOOOOOOOOOOOOOOOOOOOOoOOOOOOOOOOOOOOOOOOOOOOOOOOOODOOOOOOOODODDEODODDDD
2.000000000000000000000000 Production Started and Ready for
Shlpmentl]l]l]l]18|]|]|]|]|]|]|]|]|]|]|]|]|]|]|]|]|]7|:||:|DDDDDDDDQDDDDDDDDDDDDDDDDDDDD
3.0000002022000000800000000100000007000000000000000700000000000000A->B->A,0000000000000400000410000000000000
000000mysqid000000

« 0010 000000000000000000000000000000D0000000000000t_order_history[ll 0 100%0
o 000000/000saveByAjaxAction/saveBySubmitAction
o 000000000000000updateStatusAction
o 0000000D0000DO000DO000DupdateStatusBatchAction
« 1020 turnover function 000 1100%:0
o [0000000000DO0000D
o 0000000000040
. DD1[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I[I

° I]I]I]I]I]I]I]IsI]I]I]I]I]I]I]DDDDDDDDDDDDDDDDDDDDDDDD
00000chrome 0000000D;s0000000000000D0D00O0O00000DODODODODODAOOD
(00Van0000000000000000000000000000000 )

#8 - 08/23/2023 01:37 PM - Xihua Fan

- Description updated

#9 - 08/23/2023 06:56 PM - Zhongbao Ye
- % Done changed from 0 to 50

#10 - 08/24/2023 07:28 PM - Zhongbao Ye
- % Done changed from 50 to 80

#11 - 08/25/2023 03:45 PM - Zhongbao Ye
- Status changed from 000 to0010
- % Done changed from 80 to 100

Output(2023/08/25 1)

¢ Solution:
1. Add a new table t_order_history. Stores a record of order status changes and identifies the order operator by order_product_status = 30/60
(30: Production Started, 60:Ready for Shipment) .
2. According to the operator grouping, loop order data, calculate the order performance points, and then accumulated to the different operator's
name.
3. The turnover query interface(https://{{store_url}}/turnover/query?start=2023-08-01&finish=2023-08-28) returns the data structure:

"success": true,

"message": "",

"data": {

"productTurnovers": {
"3 |

"startDate": "2023-03-01",
"finishDate": "2023-03-01",
"color": "#BBECFF",
"id": "3",
"name": "Paper bag",
"team": "B",

"index1": "500",
"index2": "3000",
"index3": "20000",
"coefficientl": "2.50",
"coefficient2": "1.50",
"coefficient3": "1.00",
"coefficient4": "44.00",
"totalQty": 100,
"points": 45,
"express": 0,
"doubleExpress": O,
"mistakes": O,

"total": 45
}I
"126": |

"startDate": "2023-03-01",

}I

"finishDate": "2023-03-01",
"color": "#BBFFCF",
"id": "126",

"name": "Ribbon",
"team": "A",

"index1": "1",
"index2": "10",
"index3": "25",
"coefficientl": "0.50",
"coefficient2": "0.35",
"coefficient3": "0.25",
"coefficient4": "7.50",
"totalQty": 30,
"points": 55,
"express": 0,
"doubleExpress": O,
"mistakes": O,

"total": 55

"operatorDetailTurnovers": { //

T1E5Ts |

o

"startDate": "2023-03-01",
"finishDate": "2023-03-01",
"color": null,

"id": "135",

"name": "Catrin",
"index1": "500",

"index2": "3000",
"index3": "20000",
"coefficientl": "2.50",
"coefficient2": "1.50",
"coefficient3": "1.00",
"coefficient4": "44.00",
"totalQty": 102,

"points": 2,

"express": 0,
"doubleExpress": O,
"mistakes": O,

"total": 2,

"order_product_ids": "75502,75508,

RCIOCIOLE |

"startDate": "2023-03-01",
"finishDate": "2023-03-01",
"color": null,

"id": 9999,

"name": "Others",

"index1": "1",

"index2": "5",

"index3": "10",
"coefficientl": "3.00",
"coefficient2": "2.00",
"coefficient3": "1.00",
"coefficient4": "16.00",
"totalQty": 5765,
"points": 98,

"express": 0,

new
"doubleExpress": 0,
"mistakes": O,
"total": 98,
"order_product_ids": "75503,75504,75505,"
s
}I
"teamTurnovers": [
{
"color": "#BBECFF",
"team": "B",
"points": 45,
"mistakes": O,
"summation": 45,
"percentage": "45%"

"color": "#BBFFCF",
"team": "A",
"points": 55,
"mistakes": O,
"summation": 55,
"percentage": "55%"

] 4
"operatorTurnovers": [ // new
{

"color": "",
"operator_id": "135",
"operator_name": "Catrin",
"order_product_ids": "",
"points": 2,
"mistakes": O,
"summation": 2,
"percentage": "2%"

"color":
"operator_id": 9999,
"operator_name": "Others",

nn
’

"order_product_ids":
"points": 98,

nn
’

"mistakes": O,
"summation": 98,
"percentage": "98%"

}I
]!
"totalPoints": 100,
"totalMistakes": O,
"totalSummation": 100

4. Add an additional operator detail interface(
https:/{{store_url}}/turnover/operator_detail?start=2023-03-01&finish=2023-03-31&orderProductlds=75502,75508,): query the operator's current
total performance points corresponding to the order information.

e Step 1:Accessing the turnover query interface:https://{{store_url}}/turnover/query?start=2023-08-01&finish=2023-08-28

e Step 2:0pen Chrome DevTools with F12, click the Network tab to see the Response returned by query?start=2023-08-01&finish=2023-08-28
Step 3:To view the results returned by the interface. View orde_product_ids data under field operatorDetailTurnovers by operator_id, This
data is then passed to the third parameter of the operator detail interface.

e Step 4: For example, operator_id = 135, refer to the turnover query interface and use ['operatorDetailTurnovers']['135']['order_product_ids']
to get the details of the operator.

Returned data structure:

"success": true,

"message": "",

"data": [

{

"order_id": "64966",
"order_product_id": "75502",
"calndex": "RBSE49781",
"totalIndex": "65128",
"orderName": "2004052 - Ludvig & Co",
"productName": "Name badge",
"remake": "0",

"urgency": "0",
"product_type_id": "45",
"quantity": "1",
"points": "1.00",
"express": 0,
"doubleExpress": 0,
"mistakes": O,
"total": 1

}!

{
"order_id": "65168",
"order_product_id": "75508",
"caIndex": "RBSE49966",
"totalIndex": "65330",
"orderName": "173925 Karolinska
"productName": "Softwall",
"remake": "0",
"urgency": "0",
"product_type_id": "93",
"quantity": "1",
"points": "1.00",
"express": 0,
"doubleExpress": O,
"mistakes": O,
"total": 1

}

5. Operators = User Rolelloperatorlland Is Blocklfalselland Companey AbbreviationdRBSHIand Is Deletellfalsell
6. Need to show summary information for all Operators (even if it's a score of 0)

e Related code files:

protected/actions/order/UpdateStatusAction.php

Institutet",

protected/actions/order/UpdateStatusBatchAction.php

protected/actions/turnover/QueryAction.php

protected/actions/turnover/OperatorDetailAction.php(new)

protected/controllers/TurnoverController.php
protected/models/OrderHistory.php(new)
protected/services/TurnoverService.php
protected/services/UserService.php
protected/services/OrderService.php
protected/views/turnover/index.php
ui/desktop/js/turnover.js

#12 - 08/28/2023 03:31 PM - Xihua Fan

- Description updated

#13 - 08/28/2023 07:22 PM - Zhongbao Ye
- Status changed from 000 to0010
- % Done changed from 100 to 90

#14 - 08/29/2023 10:43 AM - Zhongbao Ye
- Status changed from 000 to0010
- % Done changed from 90 to 100

#15 - 08/29/2023 10:57 AM - Zhongbao Ye
- Description updated

#16 - 09/01/2023 01:35 PM - Xihua Fan
- Description updated

#17 - 09/01/2023 04:25 PM - Xihua Fan
- Description updated

#18 - 04/24/2024 05:41 PM - Xihua Fan
- Description updated

#19 - 10/08/2024 10:57 AM - Xihua Fan

- Target version set to v3.0

Files
turn over.png 387 KB 07/25/2023 Xihua Fan
